var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};

// src/index.ts
__export(exports, {
  mergeProps: () => mergeProps
});

// src/mergeProps.ts
function mergeProps(baseProps, overrideProps) {
  const mergedProps = __spreadValues({}, baseProps);
  for (const propName in baseProps) {
    const overridePropValue = overrideProps[propName];
    const basePropValue = baseProps[propName];
    const isHandler = /^on[A-Z]/.test(propName);
    if (isHandler) {
      if (overridePropValue && basePropValue) {
        mergedProps[propName] = (...args) => {
          basePropValue(...args);
          overridePropValue(...args);
        };
      } else if (overridePropValue) {
        mergedProps[propName] = overridePropValue;
      }
    } else if (propName === "style") {
      mergedProps[propName] = __spreadValues(__spreadValues({}, overridePropValue), basePropValue);
    } else if (propName === "className") {
      mergedProps[propName] = [overridePropValue, basePropValue].filter(Boolean).join(" ");
    }
  }
  return __spreadValues(__spreadValues({}, overrideProps), mergedProps);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  mergeProps
});
